# yTvz
#     TvvOC
#     w̏AskA퓬sNGXg
# yӎz
#     quest_private.pl̃Tu[`͓ǂݍ܂ĂȂƂ̂Ŋ{Iɂ͎gpȂ

package Quest::Plugin::sample_fight; # pbP[W̖͊gqt@CƓƂ

use strict; # Xy~XȂǂt₷邽ߊ{Iuse
use quest_const; # NGXg֘A̒萔gp邽ߊ{Iuse

# NGXg֘A
my $quest_name = '퓬Tv'; # NGXg

# 쌠\֘A
my $copyright_name = $quest_name; # 앨i{IɃNGXgƓj
my $copyright_ver = '1.0.1'; # o[W
my $copyright_year = '2011'; # N
my $copyright_url = 'http://www11.big.or.jp/~hazymoon/index.htm'; # URL
my $copyright_holder = 'moon'; # 쌠

# NGXgf[^֘A
my $quest_key_win = 'win'; # \L[
my $quest_key_lose = 'lose'; # sk\L[
my $quest_key_draw = 'draw'; # \L[

# ݒ֘A
my $trade_key_win = $quest_key_win; # \L[
my $trade_key_lose = $quest_key_lose; # sk\L[
my $trade_key_draw = $quest_key_draw; # \L[

# ݒf[^^Cv֘A
my %config_type_hash = (
	$quest_key_win => Quest::TYPE_FLAG_RANDOM, # z܂̓nbV
	$quest_key_lose => Quest::TYPE_FLAG_RANDOM, # z܂̓nbV
	$quest_key_draw => Quest::TYPE_FLAG_RANDOM, # z܂̓nbV
); # ݒf[^^Cv̒`

# NGXg擾ۂɌĂ΂鏈
#     yz
#         Ȃ
#     y߂lz
#         'NGXg'
sub _name{
	# NGXg߂
	return $quest_name;
}

# 쌠擾ۂɌĂ΂鏈
#     yz
#         Ȃ
#     y߂lz
#         '쌠'
sub _copyright{
	# 쌠\
	return sprintf(Quest::COPYRIGHT_LINK_FORMAT, $copyright_name, $copyright_ver, $copyright_year, $copyright_url, $copyright_holder);
}

# T|[gĂ邩ǂ擾ۂɌĂ΂鏈
#     yz
#         NGXgCũW[o[W
#         NGXgCũ}Ci[o[W
#     y߂lz
#         T|[gĂȂ^AȊO͋U
sub _support{
	my $majorVer = shift;
	my $minorVer = shift;

	# Ver.1.*T|[g
	return $majorVer == 1;
}

# ݒf[^^Cv擾ۂɌĂ΂鏈
#     yz
#         Ȃ
#     y߂lz
#         {"ݒL[1"=>f[^^CvtO,EEE,"ݒL[n"=>f[^^CvtO}
sub _type{
	return \%config_type_hash;
}

# NGXg쐬ۂɌĂ΂鏈
#     yz
#         ݒ̃nbVt@X
#         {ݒς݃NGXgf[^̃nbVt@X
#     y߂lz
#         Ȃ
sub _setup{
	my $configHashRef = shift;
	my $questHashRef = shift;

	# G[bZ[WpɎʂȂǂ擾
	my $kind = &Quest::get_kind($questHashRef);
	my $rank = int(&Quest::get_rank($questHashRef));
	my $errFormat = 'NGXgݒ肪ԈĂ܂Bi=%sAN=%dA%sj';
	# AskA肷
	my $win = int(&Quest::get_random_elem($configHashRef->{$quest_key_win}, sprintf($errFormat, $kind, $rank, '')));
	my $lose = int(&Quest::get_random_elem($configHashRef->{$quest_key_lose}, sprintf($errFormat, $kind, $rank, 'sk')));
	my $draw = int(&Quest::get_random_elem($configHashRef->{$quest_key_draw}, sprintf($errFormat, $kind, $rank, '')));
	$draw = 1 if($win == 0 && $lose == 0 && $draw == 0);
	# NGXgf[^ɏAskȀݒ肷
	$questHashRef->{$quest_key_win} = $win;
	$questHashRef->{$quest_key_lose} = $lose;
	$questHashRef->{$quest_key_draw} = $draw;
}

# B擾ۂɌĂ΂鏈
#     yz
#         NGXgf[^̃nbVt@X
#     y߂lz
#         'B'
sub _todo{
	my $questHashRef = shift;

	my $win = $questHashRef->{$quest_key_win};
	my $lose = $questHashRef->{$quest_key_lose};
	my $draw = $questHashRef->{$quest_key_draw};
	my @list = ();
	push(@list, $win . '') if($win > 0);
	push(@list, $lose . 's') if($lose > 0);
	push(@list, $draw . '') if($draw > 0);
	return sprintf('%s ̐퓬sB', join('A', map {'<span style="font-weight: bold;">' . $_ . '</span>'} @list));
}

# oߕ擾ۂɌĂ΂鏈
#     yz
#         NGXgf[^̃nbVt@X
#     y߂lz
#         'oߕ'
sub _progress{
	my $questHashRef = shift;

	my $win = $questHashRef->{$quest_key_win};
	my $lose = $questHashRef->{$quest_key_lose};
	my $draw = $questHashRef->{$quest_key_draw};
	my $progressHashRef = &Quest::get_progress($questHashRef, Quest::TYPE_FLAG_HASH);
	my $currentWin = int($progressHashRef->{$quest_key_win});
	my $currentLose = int($progressHashRef->{$quest_key_lose});
	my $currentDraw = int($progressHashRef->{$quest_key_draw});
	return sprintf('%d%ds%dic%d%ds%dj',
		$currentWin,
		$currentLose,
		$currentDraw,
		$currentWin < $win ? $win - $currentWin : 0,
		$currentLose < $lose ? $lose - $currentLose : 0,
		$currentDraw < $draw ? $draw - $currentDraw : 0
	);
}

# sۂɌĂ΂鏈
#     yz
#         NGXgf[^̃nbVt@X
#         [p[^1,EEE,p[^n]
#     y߂lz
#         sȂ^AȊO͋U
#     y⑫z
#         ؂ꂨђBς݂̏ꍇ͌Ă΂Ȃ
sub _action{
	my $questHashRef = shift;
	my $paramListRef = shift;

	# ݂̍s̒҂ł邩ǂƏsl擾ip[^[Xg1ڂ҂ł邩ǂ2ڂslƂĂj
	my $isChallenger = $paramListRef->[0];
	my $fightResult = int($paramListRef->[1]); # Ȃ琳̒lAȂ畉̒lAȂ0
	# s̏NGXgf[^擾
	my $win = $questHashRef->{$quest_key_win};
	my $lose = $questHashRef->{$quest_key_lose};
	my $draw = $questHashRef->{$quest_key_draw};
	# ݂̌o߂擾
	my $progressHashRef = &Quest::get_progress($questHashRef, Quest::TYPE_FLAG_HASH);
	my $currentWin = int($progressHashRef->{$quest_key_win});
	my $currentLose = int($progressHashRef->{$quest_key_lose});
	my $currentDraw = int($progressHashRef->{$quest_key_draw});
	my $isAction = 0;
	if($fightResult > 0){
		if($currentWin < $win){
			$isAction = 1;
			# JEgAbv
			$progressHashRef->{$quest_key_win}++;
		}
	}
	elsif($fightResult < 0){
		if($currentLose < $lose){
			$isAction = 1;
			# skJEgAbv
			$progressHashRef->{$quest_key_lose}++;
		}
	}
	else{
		if($currentDraw < $draw){
			$isAction = 1;
			# JEgAbv
			$progressHashRef->{$quest_key_draw}++;
		}
	}
	&Quest::set_progress($questHashRef, $progressHashRef);
	# ҂̍ssꂽꍇ̓bZ[W\
	&Quest::message('NGXǧo߂XV܂F ' . &_progress($questHashRef)) if($isChallenger && $isAction);
	# ssꂽꍇ͐^AȊOȂU߂
	return $isAction;
}

# B̔茋ʂ擾ۂɌĂ΂鏈
#     yz
#         NGXgf[^̃nbVt@X
#     y߂lz
#         B𖞂ĂȂ^AȊO͋U
sub _judge{
	my $questHashRef = shift;

	# s̏NGXgf[^擾
	my $win = $questHashRef->{$quest_key_win};
	my $lose = $questHashRef->{$quest_key_lose};
	my $draw = $questHashRef->{$quest_key_draw};
	# ݂̌o߂擾
	my $progressHashRef = &Quest::get_progress($questHashRef, Quest::TYPE_FLAG_HASH);
	my $currentWin = int($progressHashRef->{$quest_key_win});
	my $currentLose = int($progressHashRef->{$quest_key_lose});
	my $currentDraw = int($progressHashRef->{$quest_key_draw});
	# ݂̏s𖞂Ă邩ǂ߂
	return $currentWin >= $win && $currentLose >= $lose && $currentDraw >= $draw;
}

# ݒsۂɌĂ΂鏈
#     yz
#         [h
#         ݂̌̃nbVt@X
#         G[bZ[WZbgz񃊃t@X
#     y߂lz
#         [hɂقȂ
#             PLUGIN_CONFIG_MODE_SUPPORTF ƎݒT|[gĂꍇ͐^AȊO͋U
#             PLUGIN_CONFIG_MODE_FORMF CӁij
#             PLUGIN_CONFIG_MODE_SETF ݒ肪OK̏ꍇ͐ݒL[L[Ƃݒl̃nbVt@XAȊOundef
#             PLUGIN_CONFIG_MODE_TEXTF [[ݒ薼1,ݒl1],EEE,[ݒ薼n,ݒln]]
sub _config{
	my $mode = shift;
	my $tradeHashRef = shift;
	my $msgListRef = shift;

	if($mode eq Quest::PLUGIN_CONFIG_MODE_SUPPORT){
		return 1;
	}
	elsif($mode eq Quest::PLUGIN_CONFIG_MODE_FORM){
		# ͒lꍇ͓͒lgpAȊO͐ݒς݂̒lgp
		my $tradeWin = exists($main::Fm{$trade_key_win}) ? $main::Fm{$trade_key_win} : $tradeHashRef->{$trade_key_win};
		my $tradeLose = exists($main::Fm{$trade_key_lose}) ? $main::Fm{$trade_key_lose} : $tradeHashRef->{$trade_key_lose};
		my $tradeDraw = exists($main::Fm{$trade_key_draw}) ? $main::Fm{$trade_key_draw} : $tradeHashRef->{$trade_key_draw};
		print '<tr>';
		print '<td>ōF</td>';
		print '<td>';
		&main::input('text', $trade_key_win, $tradeWin, sprintf(' size="%d"', Quest::TEXTBOX_SIZE_SMALL), '');
		print '</td>';
		print '</tr>';
		print '<tr>';
		print '<td>ōskF</td>';
		print '<td>';
		&main::input('text', $trade_key_lose, $tradeLose, sprintf(' size="%d"', Quest::TEXTBOX_SIZE_SMALL), '');
		print '</td>';
		print '</tr>';
		print '<tr>';
		print '<td>ōF</td>';
		print '<td>';
		&main::input('text', $trade_key_draw, $tradeDraw, sprintf(' size="%d"', Quest::TEXTBOX_SIZE_SMALL), '');
		print '</td>';
		print '</tr>';
	}
	elsif($mode eq Quest::PLUGIN_CONFIG_MODE_SET){
		# ͒lgp
		my $tradeWin = $main::Fm{$trade_key_win};
		my $tradeLose = $main::Fm{$trade_key_lose};
		my $tradeDraw = $main::Fm{$trade_key_draw};
		my %hash = ();
		my $ret = \%hash;
		if($tradeWin ne ''){
			if(int($tradeWin) >= 1){
				$hash{$trade_key_win} = int($tradeWin);
			}
			else{
				undef($ret);
				push(@$msgListRef, 'ōw肷ꍇ 1 ȏ͂ĂB');
			}
		}
		if($tradeLose ne ''){
			if(int($tradeLose) >= 1){
				$hash{$trade_key_lose} = int($tradeLose);
			}
			else{
				undef($ret);
				push(@$msgListRef, 'ōskw肷ꍇ 1 ȏ͂ĂB');
			}
		}
		if($tradeDraw ne ''){
			if(int($tradeDraw) >= 1){
				$hash{$trade_key_draw} = int($tradeDraw);
			}
			else{
				undef($ret);
				push(@$msgListRef, 'ōw肷ꍇ 1 ȏ͂ĂB');
			}
		}
		return $ret;
	}
	elsif($mode eq Quest::PLUGIN_CONFIG_MODE_TEXT){
		# ݒς݂̒lgp
		my @list = ();
		push(@list, ['ō', $tradeHashRef->{$trade_key_win} . '']) if(exists($tradeHashRef->{$trade_key_win}));
		push(@list, ['ōsk', $tradeHashRef->{$trade_key_lose} . '']) if(exists($tradeHashRef->{$trade_key_lose}));
		push(@list, ['ō', $tradeHashRef->{$trade_key_draw} . '']) if(exists($tradeHashRef->{$trade_key_draw}));
		return \@list;
	}
	return;
}

# 𖞂Ă邩ǂ擾鏈
#     yz
#         ̃nbVt@X
#         NGXgf[^̃nbVt@X
#         bZ[W̔z񃊃t@X
#     y߂lz
#         𖞂ĂȂ^AȊO͋U
sub _trade{
	my $tradeHashRef = shift;
	my $questHashRef = shift;
	my $msgListRef = shift;

	my $isOK = 1;

	# ō̃`FbN
	if(exists($tradeHashRef->{$trade_key_win}) && int($questHashRef->{$quest_key_win}) > int($tradeHashRef->{$trade_key_win})){
		$isOK = 0;
		push(@$msgListRef, 'ō̏𖞂Ă܂B');
	}
	# ōsk̃`FbN
	if(exists($tradeHashRef->{$trade_key_lose}) && int($questHashRef->{$quest_key_lose}) > int($tradeHashRef->{$trade_key_lose})){
		$isOK = 0;
		push(@$msgListRef, 'ōsk̏𖞂Ă܂B');
	}
	# ō̃`FbN
	if(exists($tradeHashRef->{$trade_key_draw}) && int($questHashRef->{$quest_key_draw}) > int($tradeHashRef->{$trade_key_draw})){
		$isOK = 0;
		push(@$msgListRef, 'ō̏𖞂Ă܂B');
	}

	return $isOK;
}
